#include "MeshLoaders/AneuMeshLoader.h"

void AneuMeshLoader::LoadMesh(const std::string& filename) {
    std::ifstream meshFile(filename);
    if (!meshFile) {

    }

    std::cout << "File \"" << filename << "\" status: opened" << std::endl;
    std::cout << "Loading..." << std::endl;

    int nodesCount, dimentionCount;
    meshFile >> nodesCount >> dimentionCount;
    nodes.reserve(nodesCount);
    for (int i = 1; i <= nodesCount; ++i) {
        size_t id = i;
        std::vector<float> coordinates(dimentionCount);
        for (int j = 1; j <= dimentionCount; ++j) {
            meshFile >> coordinates[j - 1];
        }
        nodes.emplace_back(id, coordinates, true);
    }

    meshFile >> nodesCount >> dimentionCount;
    for (int i = 1; i <= nodesCount; ++i) {
        size_t id = i;
        std::vector<size_t> coordinates(dimentionCount);
        size_t materialId;
        meshFile >> materialId;
        for (int j = 1; j <= dimentionCount; ++j) {
            meshFile >> coordinates[j - 1];
        }
        finiteElements.emplace_back(id, materialId, coordinates);
    }

    meshFile >> nodesCount >> dimentionCount;
    for (int i = 1; i <= nodesCount; ++i) {
        size_t id = i;
        std::vector<size_t> coordinates(dimentionCount);
        size_t materialId;
        meshFile >> materialId;
        for (int j = 1; j <= dimentionCount; ++j) {
            meshFile >> coordinates[j - 1];
        }
        boundaryFiniteElements.emplace_back(id, materialId, coordinates);
    }

    meshFile.close();
    std::cout << "Aneu file import was successful" << std::endl;
}